#!/bin/bash
# This script will take your encrypted Amiibo .bin files
# and send them to the Amiibo Decryption Service.
# This service ONLY accepts binary dumps.
# It will verify that it is a valid dump and then return
# a decrypted version back to you.
# ERROR 6 means it is an invalid dump

location="D:/WiiU/Amiibo/" #location of .bin files
decryptedlocation="D:/WiiU/Amiibo/Decrypted/" #location you want the decrypted version sent to

########################################
#DON'T CHANGE ANYTHING BELOW THIS LINE!#
########################################

cd $location

echo -e "\nAmiibo Decryption Service Script by Summersett (9/13/15)\n"
echo "Your Amiibo files in $location:"
find -maxdepth 1 -type f -name '*.bin' -exec echo \{\} \; 

echo -e "\nType the name of the Amiibo file you want decrypted,\nor type ALL to decrypt everything in the folder:\n"
read "binName"
echo -e "\n"

if [ "$binName" == "ALL" ]||[ "$binName" == "all" ] ; then # If ALL or all entered, process all .bin files
	for file in *.bin
	do
		if [ "$location" == "$decryptedlocation" ] ; then
			binNameOut="$file-decrypted"
		else
			binNameOut="$file"
		fi
		binName="$file"
		
		echo -n "Processing $binName... "
		cat "$binName" | nc 151.80.162.73 22403 > "$decryptedlocation""$binNameOut"
		echo -e "Finished!"
	done
else
	if [ -e "$binName" ] ; then #If <file.bin> entered, process file
		if [ "$location" == "$decryptedlocation" ] ; then
			binNameOut="$binName-decrypted"
		else
			binNameOut="$binName"
		fi
		
		echo -n "Processing $binName... "
		cat "$binName" | nc 151.80.162.73 22403 > "$decryptedlocation""$binNameOut"
		echo -e "Finished!"
	elif [ -e "$binName".bin ] ; then #If <file> entered without extension, put .bin on the end and process
		binName="$binName.bin"
				
		echo -n "Processing $binName... "
		if [ "$location" == "$decryptedlocation" ] ; then
			binNameOut="$binName-decrypted"
		else
			binNameOut="$binName"
		fi
		
		cat "$binName" | nc 151.80.162.73 22403 > "$decryptedlocation""$binNameOut"
		echo -e "Finished!"
	else
		echo -e "No file: $binName\n"
	fi
fi

echo -e "\n"
read -p "Press [Enter] to quit"